/*
 * Copyright © 2011 Linaro Limited
 *
 * This file is part of glcompbench.
 *
 * glcompbench is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * glcompbench is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with glcompbench.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *  Alexandros Frantzis <alexandros.frantzis@linaro.org>
 *  Jesse Barker <jesse.barker@linaro.org>
 */

#ifndef COMPOSITE_CANVAS_EGL_H_
#define COMPOSITE_CANVAS_EGL_H_

#include <EGL/egl.h>
#include "composite-canvas.h"

class CompositeCanvasEGL: public CompositeCanvas
{
public:
    CompositeCanvasEGL() :
        CompositeCanvas(),
        egl_display_(0), egl_config_(0),
        egl_context_(0), egl_surface_(0),
        use_accel_tfp_(false) {}

    std::string info_string();

protected:
    XVisualInfo *get_canvas_xvisualinfo();
    bool make_current();
    CompositeWindow *create_window(Window win);
    void update_screen();

private:
    bool check_eglimage_extensions();

    EGLDisplay egl_display_;
    EGLConfig  egl_config_;
    EGLContext egl_context_;
    EGLSurface egl_surface_;
    bool use_accel_tfp_;

    bool ensure_egl_display();
    bool ensure_egl_config();
    bool ensure_egl_surface();
};

#endif /* COMPOSITE_CANVAS_EGL_H_ */
