/*
 * Copyright © 2011 Linaro Limited
 *
 * This file is part of glcompbench.
 *
 * glcompbench is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * glcompbench is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with glcompbench.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *  Alexandros Frantzis <alexandros.frantzis@linaro.org>
 *  Jesse Barker <jesse.barker@linaro.org>
 */

#ifndef COMPOSITE_CANVAS_GLX_H_
#define COMPOSITE_CANVAS_GLX_H_

#include <GL/glx.h>
#include "composite-canvas.h"

class CompositeCanvasGLX: public CompositeCanvas
{
public:
    CompositeCanvasGLX() :
        CompositeCanvas(),
        glx_fbconfig_(0), glx_context_(0),
        use_accel_tfp_(false) {}

    std::string info_string();

protected:
    XVisualInfo *get_canvas_xvisualinfo();
    bool make_current();
    CompositeWindow *create_window(Window win);
    void update_screen();

private:
    bool check_glx_version();
    void init_extensions();

    GLXFBConfig glx_fbconfig_;
    GLXContext glx_context_;
    bool use_accel_tfp_;

    bool ensure_glx_fbconfig();
    bool ensure_glx_context();
};

#endif /* COMPOSITE_CANVAS_GLX_H_ */
