/*
 * Copyright © 2011 Linaro Limited
 *
 * This file is part of glcompbench.
 *
 * glcompbench is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * glcompbench is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with glcompbench.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *  Alexandros Frantzis <alexandros.frantzis@linaro.org>
 *  Jesse Barker <jesse.barker@linaro.org>
 */

#include "composite-test.h"
#include "options.h"
#include "benchmark.h"

/**
 * Prepares the test for a test run.
 */
void
CompositeTestDefaultOptions::prepare_for_run()
{
    const std::map<std::string, CompositeTest *> &tests = Benchmark::tests();

    for (std::list<std::pair<std::string, std::string> >::const_iterator iter = default_options_.begin();
         iter != default_options_.end();
         iter++)
    {
        for (std::map<std::string, CompositeTest *>::const_iterator test_iter = tests.begin();
             test_iter != tests.end();
             test_iter++)
        {
            test_iter->second->set_option_default(iter->first, iter->second);
        }
    }
}

bool
CompositeTestDefaultOptions::set_option(const std::string &opt,
                                        const std::string &val)
{
    default_options_.push_back(std::pair<std::string, std::string>(opt, val));
    return true;
}
