/*
 * Copyright © 2011 Linaro Limited
 *
 * This file is part of glcompbench.
 *
 * glcompbench is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * glcompbench is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with glcompbench.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *  Alexandros Frantzis <alexandros.frantzis@linaro.org>
 *  Jesse Barker <jesse.barker@linaro.org>
 */

#ifndef COMPOSITE_WINDOW_EGLIMAGE_H_
#define COMPOSITE_WINDOW_EGLIMAGE_H_

#include <X11/Xlib.h>
#include "gl-headers.h"
#include <EGL/egl.h>
#include <EGL/eglext.h>
#include "composite-window.h"

class CompositeWindowEGLImage : public CompositeWindow
{
public:
    CompositeWindowEGLImage(Display *xdpy, Window win,
                            EGLDisplay egl_display) :
        CompositeWindow(xdpy, win),
        egl_image_(0), egl_display_(egl_display) {}
    ~CompositeWindowEGLImage();

    void update_texture_from_pixmap(bool recreate);

private:
    EGLImageKHR egl_image_;
    EGLDisplay egl_display_;
};

#endif /* COMPOSITE_WINDOW_EGLIMAGE_H */
