/*
 * Copyright © 2011 Linaro Limited
 *
 * This file is part of glcompbench.
 *
 * glcompbench is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * glcompbench is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with glcompbench.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *  Alexandros Frantzis <alexandros.frantzis@linaro.org>
 *  Jesse Barker <jesse.barker@linaro.org>
 */

#ifndef COMPOSITE_WINDOW_GLXPIXMAP_H_
#define COMPOSITE_WINDOW_GLXPIXMAP_H_

#include <X11/Xlib.h>
#include <GL/glx.h>
#include "composite-window.h"

class CompositeWindowGLXPixmap : public CompositeWindow
{
public:
    CompositeWindowGLXPixmap(Display *xdpy, Window win,
                             GLXFBConfig glx_fbconfig) :
        CompositeWindow(xdpy, win), glx_pixmap_(0),
        glx_fbconfig_ (glx_fbconfig) {}
    ~CompositeWindowGLXPixmap();

    void update_texture_from_pixmap(bool recreate);

private:
    GLXPixmap glx_pixmap_;
    GLXFBConfig glx_fbconfig_;
};

#endif /* COMPOSITE_WINDOW_GLXPIXMAP_H */
