/*
 * Copyright © 2011 Linaro Limited
 *
 * This file is part of glcompbench.
 *
 * glcompbench is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * glcompbench is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with glcompbench.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *  Alexandros Frantzis <alexandros.frantzis@linaro.org>
 *  Jesse Barker <jesse.barker@linaro.org>
 */

#ifndef COMPOSITE_WINDOW_XIMAGE_H_
#define COMPOSITE_WINDOW_XIMAGE_H_

#include <X11/Xlib.h>
#include "gl-headers.h"
#include "composite-window.h"

class CompositeWindowXImage : public CompositeWindow
{
public:
    CompositeWindowXImage(Display *xdpy, Window win) :
        CompositeWindow(xdpy, win), ximage_(0) {}
    ~CompositeWindowXImage();

    void update_texture_from_pixmap(bool recreate);

private:
    XImage *ximage_;
};

#endif
