/*
 * Copyright © 2011 Linaro Limited
 *
 * This file is part of glcompbench.
 *
 * glcompbench is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * glcompbench is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with glcompbench.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *  Alexandros Frantzis <alexandros.frantzis@linaro.org>
 *  Jesse Barker <jesse.barker@linaro.org>
 */

#ifndef OPTIONS_H_
#define OPTIONS_H_

#include <X11/Xlib.h>
#include <list>
#include <string>

struct Options {
    static bool parse_args(int argc, char **argv);
    static void print_help();

    static std::list<Window> window_ids;
    static int size;
    static bool run_forever;
    static bool use_accel_tfp;
    static std::list<std::string> benchmarks;
    static bool draw;
    static bool idle_redraw;
    static bool force_tex_update;
    static bool manual_redirect;
    static bool show_debug;
    static bool show_help;
    static bool list_tests;
    static bool swap_buffers;
};

#endif /* OPTIONS_H_ */
